"use strict";
var Enemy = function(blueprint, override) {
	this.type = game.getObjectTypes().ENEMY;
	var baseParameters = {
		A : 0,
		B : 0,
		C : 0,
		D : 0,
		E : 0,
		F : 0,
		G : 0,
		H : 0,
		t : 0
	};
	this.merge(baseParameters);
	this.setup(blueprint.sprite, blueprint);
	this.merge(override);

	this.step = function(dt) {
		this.t += dt;

		this.vx = this.A + this.B * Math.sin(this.C * this.t + this.D);
		this.vy = this.E + this.F * Math.sin(this.G * this.t + this.H);

		this.x += this.vx * dt;
		this.y += this.vy * dt;

		var collision = this.board.collide(this, game.getObjectTypes().PLAYER);
		if (collision) {
			collision.hit(this.damage);
			this.board.remove(this);
		} else if (this.y > game.getHeight() || this.x < -this.w
				|| this.x > game.getWidth()) {
			this.board.remove(this);
		}
	};
};

game.inherit(Enemy, Sprite);
