"use strict";
var PlayerShip = function() {
	this.type  = game.getObjectTypes().PLAYER;
	this.setup('ship');
	this.x = game.getWidth() / 2 - this.w / 2;
	this.y = game.getHeight() - config.bottomOffset - this.h;
	this.vx = 0;
	this.vy = 0;
	this.reloadTime = 0.25; // Quarter second reload
	this.reload = this.reloadTime;
	this.maxVel = 200;

	this.step = function(dt) {
		if (game.keys['left']) {
			this.vx = -this.maxVel;
		} else if (game.keys['right']) {
			this.vx = this.maxVel;
		} else if (game.keys['up']) {
			this.vy = -this.maxVel;
		} else if (game.keys['down']) {
			this.vy = this.maxVel;
		} else {
			this.vx = 0;
			this.vy = 0;
		}

		this.x += this.vx * dt;
		this.y += this.vy * dt;

		if (this.x < 0) {
			this.x = 0;
		} else if (this.x > game.getWidth() - this.w) {
			this.x = game.getWidth() - this.w;
		}

		if (this.y < 0) {
			this.y = 0;
		} else if (this.y > game.getHeight() - config.bottomOffset - this.h) {
			this.y = game.getHeight() - config.bottomOffset - this.h;
		}

		this.reload -= dt;
		if (game.keys['fire'] && this.reload < 0) {
			game.keys['fire'] = false;
			this.reload = this.reloadTime;

			this.board.add(new PlayerMissile(this.x, this.y + this.h / 2));
			this.board.add(new PlayerMissile(this.x + this.w, this.y + this.h
					/ 2));
		}

		this.vx = 0;
		this.vy = 0;
	};
};

game.inherit(PlayerShip, Sprite);
