"use strict";
var game = (function() {
	var canvas;
	var ctx;
	var boards = [];
	var width;
	var height;
	var fps;
	var realFps;
	var period;
	var objectTypes = {
		PLAYER : 1,
		PLAYER_MISSILE : 2,
		ENEMY : 4,
		ENEMY_MISSILE : 8
	};
	var debug = true;

	var enemies = {
		basic : {
			x : 100,
			y : -50,
			sprite : 'enemy_purple',
			B : 100,
			C : 2,
			E : 100
		}
	};

	var loop = function() {
		ctx.fillStyle = "#000";
		ctx.fillRect(0, 0, width, height);
		var dt = period / 1000;
		for ( var i = 0, len = boards.length; i < len; i++) {
			if (boards[i]) {
				boards[i].step(dt);
				boards[i].draw(ctx);
			}
		}
		setTimeout(loop, period);
	};

	var setBoard = function(num, board) {
		boards[num] = board;
	};

	return {
		keys : [],
		checkEnviroment : function() {
			game.log("checkEnviroment");
			canvas = document.getElementById('game');
			ctx = canvas.getContext && canvas.getContext('2d');
			if (!ctx || typeof window.addEventListener !== "function") {
				alert("Please upgrade your browser!");
				return false;
			}
			width = canvas.width;
			document.getElementById('container').style.width = width + 'px';
			height = canvas.height;
			return true;
		},

		initialize : function() {
			game.log("initialize");
			fps = config.fps;
			period = 1 / (fps / 1000);
			game.log("fps = " + fps);
			game.log("period = " + period + "ms");
			spriteSheet.load(function() {
				setBoard(3, new TitleScreen("Earth Guard", "Tap/click to fight!", function() {
					var board = new GameBoard();
					board.add(new PlayerShip());
					setBoard(3, board);
					// random Enemies
					setInterval(function() {
						board.add(new Enemy(enemies.basic, {
							x : (150 * Math.random())
						}));
						board.add(new Enemy(enemies.basic, {
							x : (150 * Math.random()) + 400
						}));
					}, 2000);
				}));
				loop();
			});
		},
		getWidth : function() {
			return width;
		},
		getHeight : function() {
			return height;
		},
		getObjectTypes : function() {
			return objectTypes;
		},
		// This method defines standard prototype inheritance
		inherit : function(child, parent) {
			child.prototype = new parent();
		},
		log : function(txt) {
			if (debug && typeof console !== "undefined")
				console.log(txt);
		}
	};
})();
